// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: wlq/tx.proto

package types

import (
	context "context"
	fmt "fmt"
	grpc1 "github.com/gogo/protobuf/grpc"
	proto "github.com/gogo/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	io "io"
	math "math"
	math_bits "math/bits"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

type MsgJoinQueue struct {
	Creator string `protobuf:"bytes,1,opt,name=creator,proto3" json:"creator,omitempty"`
	Tier    uint64 `protobuf:"varint,2,opt,name=tier,proto3" json:"tier,omitempty"`
	SizeId  uint64 `protobuf:"varint,3,opt,name=sizeId,proto3" json:"sizeId,omitempty"`
}

func (m *MsgJoinQueue) Reset()         { *m = MsgJoinQueue{} }
func (m *MsgJoinQueue) String() string { return proto.CompactTextString(m) }
func (*MsgJoinQueue) ProtoMessage()    {}
func (*MsgJoinQueue) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{0}
}
func (m *MsgJoinQueue) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgJoinQueue) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgJoinQueue.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgJoinQueue) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgJoinQueue.Merge(m, src)
}
func (m *MsgJoinQueue) XXX_Size() int {
	return m.Size()
}
func (m *MsgJoinQueue) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgJoinQueue.DiscardUnknown(m)
}

var xxx_messageInfo_MsgJoinQueue proto.InternalMessageInfo

func (m *MsgJoinQueue) GetCreator() string {
	if m != nil {
		return m.Creator
	}
	return ""
}

func (m *MsgJoinQueue) GetTier() uint64 {
	if m != nil {
		return m.Tier
	}
	return 0
}

func (m *MsgJoinQueue) GetSizeId() uint64 {
	if m != nil {
		return m.SizeId
	}
	return 0
}

type MsgJoinQueueResponse struct {
}

func (m *MsgJoinQueueResponse) Reset()         { *m = MsgJoinQueueResponse{} }
func (m *MsgJoinQueueResponse) String() string { return proto.CompactTextString(m) }
func (*MsgJoinQueueResponse) ProtoMessage()    {}
func (*MsgJoinQueueResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{1}
}
func (m *MsgJoinQueueResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgJoinQueueResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgJoinQueueResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgJoinQueueResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgJoinQueueResponse.Merge(m, src)
}
func (m *MsgJoinQueueResponse) XXX_Size() int {
	return m.Size()
}
func (m *MsgJoinQueueResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgJoinQueueResponse.DiscardUnknown(m)
}

var xxx_messageInfo_MsgJoinQueueResponse proto.InternalMessageInfo

type MsgSubmitMove struct {
	Creator string `protobuf:"bytes,1,opt,name=creator,proto3" json:"creator,omitempty"`
	GameId  uint64 `protobuf:"varint,2,opt,name=gameId,proto3" json:"gameId,omitempty"`
	X       int32  `protobuf:"varint,3,opt,name=x,proto3" json:"x,omitempty"`
	Y       int32  `protobuf:"varint,4,opt,name=y,proto3" json:"y,omitempty"`
}

func (m *MsgSubmitMove) Reset()         { *m = MsgSubmitMove{} }
func (m *MsgSubmitMove) String() string { return proto.CompactTextString(m) }
func (*MsgSubmitMove) ProtoMessage()    {}
func (*MsgSubmitMove) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{2}
}
func (m *MsgSubmitMove) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgSubmitMove) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgSubmitMove.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgSubmitMove) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgSubmitMove.Merge(m, src)
}
func (m *MsgSubmitMove) XXX_Size() int {
	return m.Size()
}
func (m *MsgSubmitMove) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgSubmitMove.DiscardUnknown(m)
}

var xxx_messageInfo_MsgSubmitMove proto.InternalMessageInfo

func (m *MsgSubmitMove) GetCreator() string {
	if m != nil {
		return m.Creator
	}
	return ""
}

func (m *MsgSubmitMove) GetGameId() uint64 {
	if m != nil {
		return m.GameId
	}
	return 0
}

func (m *MsgSubmitMove) GetX() int32 {
	if m != nil {
		return m.X
	}
	return 0
}

func (m *MsgSubmitMove) GetY() int32 {
	if m != nil {
		return m.Y
	}
	return 0
}

type MsgSubmitMoveResponse struct {
}

func (m *MsgSubmitMoveResponse) Reset()         { *m = MsgSubmitMoveResponse{} }
func (m *MsgSubmitMoveResponse) String() string { return proto.CompactTextString(m) }
func (*MsgSubmitMoveResponse) ProtoMessage()    {}
func (*MsgSubmitMoveResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{3}
}
func (m *MsgSubmitMoveResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgSubmitMoveResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgSubmitMoveResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgSubmitMoveResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgSubmitMoveResponse.Merge(m, src)
}
func (m *MsgSubmitMoveResponse) XXX_Size() int {
	return m.Size()
}
func (m *MsgSubmitMoveResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgSubmitMoveResponse.DiscardUnknown(m)
}

var xxx_messageInfo_MsgSubmitMoveResponse proto.InternalMessageInfo

type MsgLeaveQueue struct {
	Creator string `protobuf:"bytes,1,opt,name=creator,proto3" json:"creator,omitempty"`
	Tier    uint64 `protobuf:"varint,2,opt,name=tier,proto3" json:"tier,omitempty"`
	SizeId  uint64 `protobuf:"varint,3,opt,name=sizeId,proto3" json:"sizeId,omitempty"`
}

func (m *MsgLeaveQueue) Reset()         { *m = MsgLeaveQueue{} }
func (m *MsgLeaveQueue) String() string { return proto.CompactTextString(m) }
func (*MsgLeaveQueue) ProtoMessage()    {}
func (*MsgLeaveQueue) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{4}
}
func (m *MsgLeaveQueue) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgLeaveQueue) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgLeaveQueue.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgLeaveQueue) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgLeaveQueue.Merge(m, src)
}
func (m *MsgLeaveQueue) XXX_Size() int {
	return m.Size()
}
func (m *MsgLeaveQueue) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgLeaveQueue.DiscardUnknown(m)
}

var xxx_messageInfo_MsgLeaveQueue proto.InternalMessageInfo

func (m *MsgLeaveQueue) GetCreator() string {
	if m != nil {
		return m.Creator
	}
	return ""
}

func (m *MsgLeaveQueue) GetTier() uint64 {
	if m != nil {
		return m.Tier
	}
	return 0
}

func (m *MsgLeaveQueue) GetSizeId() uint64 {
	if m != nil {
		return m.SizeId
	}
	return 0
}

type MsgLeaveQueueResponse struct {
}

func (m *MsgLeaveQueueResponse) Reset()         { *m = MsgLeaveQueueResponse{} }
func (m *MsgLeaveQueueResponse) String() string { return proto.CompactTextString(m) }
func (*MsgLeaveQueueResponse) ProtoMessage()    {}
func (*MsgLeaveQueueResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0850192065c10644, []int{5}
}
func (m *MsgLeaveQueueResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MsgLeaveQueueResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MsgLeaveQueueResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MsgLeaveQueueResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MsgLeaveQueueResponse.Merge(m, src)
}
func (m *MsgLeaveQueueResponse) XXX_Size() int {
	return m.Size()
}
func (m *MsgLeaveQueueResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_MsgLeaveQueueResponse.DiscardUnknown(m)
}

var xxx_messageInfo_MsgLeaveQueueResponse proto.InternalMessageInfo

func init() {
	proto.RegisterType((*MsgJoinQueue)(nil), "marcus.appelros.wlqtest.wlq.MsgJoinQueue")
	proto.RegisterType((*MsgJoinQueueResponse)(nil), "marcus.appelros.wlqtest.wlq.MsgJoinQueueResponse")
	proto.RegisterType((*MsgSubmitMove)(nil), "marcus.appelros.wlqtest.wlq.MsgSubmitMove")
	proto.RegisterType((*MsgSubmitMoveResponse)(nil), "marcus.appelros.wlqtest.wlq.MsgSubmitMoveResponse")
	proto.RegisterType((*MsgLeaveQueue)(nil), "marcus.appelros.wlqtest.wlq.MsgLeaveQueue")
	proto.RegisterType((*MsgLeaveQueueResponse)(nil), "marcus.appelros.wlqtest.wlq.MsgLeaveQueueResponse")
}

func init() { proto.RegisterFile("wlq/tx.proto", fileDescriptor_0850192065c10644) }

var fileDescriptor_0850192065c10644 = []byte{
	// 339 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x93, 0x31, 0x4f, 0xf2, 0x40,
	0x1c, 0xc6, 0x39, 0xe0, 0xe5, 0x0d, 0xff, 0xe0, 0x72, 0x51, 0x6c, 0x30, 0x69, 0x48, 0x27, 0x74,
	0xb8, 0x46, 0xfc, 0x06, 0x4e, 0x6a, 0xec, 0x60, 0xd5, 0xc5, 0xc4, 0xa1, 0xe0, 0x3f, 0xcd, 0x25,
	0x2d, 0x57, 0xee, 0xae, 0x50, 0xfc, 0x14, 0x7e, 0x2c, 0x07, 0x07, 0x46, 0x47, 0x03, 0x5f, 0xc4,
	0x70, 0x80, 0xad, 0x9a, 0x00, 0x83, 0x53, 0xfb, 0x34, 0x4f, 0x7e, 0xbf, 0xf4, 0xb9, 0x1c, 0x34,
	0xc6, 0xd1, 0xd0, 0xd5, 0x19, 0x4b, 0xa4, 0xd0, 0x82, 0x1e, 0xc5, 0x81, 0xec, 0xa7, 0x8a, 0x05,
	0x49, 0x82, 0x91, 0x14, 0x8a, 0x8d, 0xa3, 0xa1, 0x46, 0xa5, 0x17, 0x4f, 0xe7, 0x0e, 0x1a, 0x9e,
	0x0a, 0xaf, 0x04, 0x1f, 0xdc, 0xa4, 0x98, 0x22, 0xb5, 0xe0, 0x7f, 0x5f, 0x62, 0xa0, 0x85, 0xb4,
	0x48, 0x9b, 0x74, 0xea, 0xfe, 0x3a, 0x52, 0x0a, 0x55, 0xcd, 0x51, 0x5a, 0xe5, 0x36, 0xe9, 0x54,
	0x7d, 0xf3, 0x4e, 0x9b, 0x50, 0x53, 0xfc, 0x19, 0x2f, 0x9f, 0xac, 0x8a, 0xf9, 0xba, 0x4a, 0x4e,
	0x13, 0xf6, 0x8b, 0x54, 0x1f, 0x55, 0x22, 0x06, 0x0a, 0x9d, 0x47, 0xd8, 0xf3, 0x54, 0x78, 0x9b,
	0xf6, 0x62, 0xae, 0x3d, 0x31, 0xda, 0xa4, 0x6b, 0x42, 0x2d, 0x0c, 0xe2, 0x05, 0x7a, 0x29, 0x5c,
	0x25, 0xda, 0x00, 0x92, 0x19, 0xdb, 0x3f, 0x9f, 0x64, 0x8b, 0x34, 0xb1, 0xaa, 0xcb, 0x34, 0x71,
	0x0e, 0xe1, 0xe0, 0x1b, 0xfe, 0xcb, 0x7b, 0x6f, 0xbc, 0xd7, 0x18, 0x8c, 0xf0, 0x2f, 0x7f, 0x73,
	0xe9, 0xcb, 0xb1, 0x6b, 0x5f, 0xf7, 0xad, 0x0c, 0x15, 0x4f, 0x85, 0x94, 0x43, 0x3d, 0x9f, 0xf6,
	0x98, 0x6d, 0x38, 0x08, 0x56, 0xdc, 0xab, 0x75, 0xba, 0x73, 0x75, 0xad, 0xa4, 0x11, 0x40, 0x61,
	0xd7, 0x93, 0x6d, 0x80, 0xbc, 0xdb, 0xea, 0xee, 0xde, 0x2d, 0xda, 0x0a, 0x6b, 0x6e, 0xb5, 0xe5,
	0xdd, 0xed, 0xb6, 0xdf, 0x73, 0x9e, 0x5f, 0xbc, 0xce, 0x6c, 0x32, 0x9d, 0xd9, 0xe4, 0x63, 0x66,
	0x93, 0x97, 0xb9, 0x5d, 0x9a, 0xce, 0xed, 0xd2, 0xfb, 0xdc, 0x2e, 0x3d, 0xb0, 0x90, 0xeb, 0x28,
	0xe8, 0xb1, 0xbe, 0x88, 0xdd, 0x1f, 0x5c, 0x77, 0xc5, 0x75, 0x33, 0xd7, 0x5c, 0x87, 0x49, 0x82,
	0xaa, 0x57, 0x33, 0x57, 0xe2, 0xec, 0x33, 0x00, 0x00, 0xff, 0xff, 0xc2, 0x14, 0xa7, 0x0b, 0x22,
	0x03, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// MsgClient is the client API for Msg service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type MsgClient interface {
	JoinQueue(ctx context.Context, in *MsgJoinQueue, opts ...grpc.CallOption) (*MsgJoinQueueResponse, error)
	SubmitMove(ctx context.Context, in *MsgSubmitMove, opts ...grpc.CallOption) (*MsgSubmitMoveResponse, error)
	LeaveQueue(ctx context.Context, in *MsgLeaveQueue, opts ...grpc.CallOption) (*MsgLeaveQueueResponse, error)
}

type msgClient struct {
	cc grpc1.ClientConn
}

func NewMsgClient(cc grpc1.ClientConn) MsgClient {
	return &msgClient{cc}
}

func (c *msgClient) JoinQueue(ctx context.Context, in *MsgJoinQueue, opts ...grpc.CallOption) (*MsgJoinQueueResponse, error) {
	out := new(MsgJoinQueueResponse)
	err := c.cc.Invoke(ctx, "/marcus.appelros.wlqtest.wlq.Msg/JoinQueue", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *msgClient) SubmitMove(ctx context.Context, in *MsgSubmitMove, opts ...grpc.CallOption) (*MsgSubmitMoveResponse, error) {
	out := new(MsgSubmitMoveResponse)
	err := c.cc.Invoke(ctx, "/marcus.appelros.wlqtest.wlq.Msg/SubmitMove", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *msgClient) LeaveQueue(ctx context.Context, in *MsgLeaveQueue, opts ...grpc.CallOption) (*MsgLeaveQueueResponse, error) {
	out := new(MsgLeaveQueueResponse)
	err := c.cc.Invoke(ctx, "/marcus.appelros.wlqtest.wlq.Msg/LeaveQueue", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MsgServer is the server API for Msg service.
type MsgServer interface {
	JoinQueue(context.Context, *MsgJoinQueue) (*MsgJoinQueueResponse, error)
	SubmitMove(context.Context, *MsgSubmitMove) (*MsgSubmitMoveResponse, error)
	LeaveQueue(context.Context, *MsgLeaveQueue) (*MsgLeaveQueueResponse, error)
}

// UnimplementedMsgServer can be embedded to have forward compatible implementations.
type UnimplementedMsgServer struct {
}

func (*UnimplementedMsgServer) JoinQueue(ctx context.Context, req *MsgJoinQueue) (*MsgJoinQueueResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method JoinQueue not implemented")
}
func (*UnimplementedMsgServer) SubmitMove(ctx context.Context, req *MsgSubmitMove) (*MsgSubmitMoveResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SubmitMove not implemented")
}
func (*UnimplementedMsgServer) LeaveQueue(ctx context.Context, req *MsgLeaveQueue) (*MsgLeaveQueueResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LeaveQueue not implemented")
}

func RegisterMsgServer(s grpc1.Server, srv MsgServer) {
	s.RegisterService(&_Msg_serviceDesc, srv)
}

func _Msg_JoinQueue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MsgJoinQueue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MsgServer).JoinQueue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/marcus.appelros.wlqtest.wlq.Msg/JoinQueue",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MsgServer).JoinQueue(ctx, req.(*MsgJoinQueue))
	}
	return interceptor(ctx, in, info, handler)
}

func _Msg_SubmitMove_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MsgSubmitMove)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MsgServer).SubmitMove(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/marcus.appelros.wlqtest.wlq.Msg/SubmitMove",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MsgServer).SubmitMove(ctx, req.(*MsgSubmitMove))
	}
	return interceptor(ctx, in, info, handler)
}

func _Msg_LeaveQueue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MsgLeaveQueue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MsgServer).LeaveQueue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/marcus.appelros.wlqtest.wlq.Msg/LeaveQueue",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MsgServer).LeaveQueue(ctx, req.(*MsgLeaveQueue))
	}
	return interceptor(ctx, in, info, handler)
}

var _Msg_serviceDesc = grpc.ServiceDesc{
	ServiceName: "marcus.appelros.wlqtest.wlq.Msg",
	HandlerType: (*MsgServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "JoinQueue",
			Handler:    _Msg_JoinQueue_Handler,
		},
		{
			MethodName: "SubmitMove",
			Handler:    _Msg_SubmitMove_Handler,
		},
		{
			MethodName: "LeaveQueue",
			Handler:    _Msg_LeaveQueue_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "wlq/tx.proto",
}

func (m *MsgJoinQueue) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgJoinQueue) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgJoinQueue) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.SizeId != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.SizeId))
		i--
		dAtA[i] = 0x18
	}
	if m.Tier != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.Tier))
		i--
		dAtA[i] = 0x10
	}
	if len(m.Creator) > 0 {
		i -= len(m.Creator)
		copy(dAtA[i:], m.Creator)
		i = encodeVarintTx(dAtA, i, uint64(len(m.Creator)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *MsgJoinQueueResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgJoinQueueResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgJoinQueueResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	return len(dAtA) - i, nil
}

func (m *MsgSubmitMove) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgSubmitMove) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgSubmitMove) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.Y != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.Y))
		i--
		dAtA[i] = 0x20
	}
	if m.X != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.X))
		i--
		dAtA[i] = 0x18
	}
	if m.GameId != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.GameId))
		i--
		dAtA[i] = 0x10
	}
	if len(m.Creator) > 0 {
		i -= len(m.Creator)
		copy(dAtA[i:], m.Creator)
		i = encodeVarintTx(dAtA, i, uint64(len(m.Creator)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *MsgSubmitMoveResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgSubmitMoveResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgSubmitMoveResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	return len(dAtA) - i, nil
}

func (m *MsgLeaveQueue) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgLeaveQueue) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgLeaveQueue) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.SizeId != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.SizeId))
		i--
		dAtA[i] = 0x18
	}
	if m.Tier != 0 {
		i = encodeVarintTx(dAtA, i, uint64(m.Tier))
		i--
		dAtA[i] = 0x10
	}
	if len(m.Creator) > 0 {
		i -= len(m.Creator)
		copy(dAtA[i:], m.Creator)
		i = encodeVarintTx(dAtA, i, uint64(len(m.Creator)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *MsgLeaveQueueResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MsgLeaveQueueResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MsgLeaveQueueResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	return len(dAtA) - i, nil
}

func encodeVarintTx(dAtA []byte, offset int, v uint64) int {
	offset -= sovTx(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *MsgJoinQueue) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Creator)
	if l > 0 {
		n += 1 + l + sovTx(uint64(l))
	}
	if m.Tier != 0 {
		n += 1 + sovTx(uint64(m.Tier))
	}
	if m.SizeId != 0 {
		n += 1 + sovTx(uint64(m.SizeId))
	}
	return n
}

func (m *MsgJoinQueueResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	return n
}

func (m *MsgSubmitMove) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Creator)
	if l > 0 {
		n += 1 + l + sovTx(uint64(l))
	}
	if m.GameId != 0 {
		n += 1 + sovTx(uint64(m.GameId))
	}
	if m.X != 0 {
		n += 1 + sovTx(uint64(m.X))
	}
	if m.Y != 0 {
		n += 1 + sovTx(uint64(m.Y))
	}
	return n
}

func (m *MsgSubmitMoveResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	return n
}

func (m *MsgLeaveQueue) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Creator)
	if l > 0 {
		n += 1 + l + sovTx(uint64(l))
	}
	if m.Tier != 0 {
		n += 1 + sovTx(uint64(m.Tier))
	}
	if m.SizeId != 0 {
		n += 1 + sovTx(uint64(m.SizeId))
	}
	return n
}

func (m *MsgLeaveQueueResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	return n
}

func sovTx(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozTx(x uint64) (n int) {
	return sovTx(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *MsgJoinQueue) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgJoinQueue: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgJoinQueue: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Creator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthTx
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthTx
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Creator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Tier", wireType)
			}
			m.Tier = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Tier |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field SizeId", wireType)
			}
			m.SizeId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.SizeId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MsgJoinQueueResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgJoinQueueResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgJoinQueueResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MsgSubmitMove) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgSubmitMove: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgSubmitMove: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Creator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthTx
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthTx
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Creator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field GameId", wireType)
			}
			m.GameId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.GameId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field X", wireType)
			}
			m.X = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.X |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Y", wireType)
			}
			m.Y = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Y |= int32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MsgSubmitMoveResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgSubmitMoveResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgSubmitMoveResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MsgLeaveQueue) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgLeaveQueue: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgLeaveQueue: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Creator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthTx
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthTx
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Creator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Tier", wireType)
			}
			m.Tier = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Tier |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field SizeId", wireType)
			}
			m.SizeId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTx
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.SizeId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MsgLeaveQueueResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTx
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MsgLeaveQueueResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MsgLeaveQueueResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		default:
			iNdEx = preIndex
			skippy, err := skipTx(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthTx
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipTx(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowTx
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowTx
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowTx
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthTx
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupTx
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthTx
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthTx        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowTx          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupTx = fmt.Errorf("proto: unexpected end of group")
)
